# Kusto

> see https://aka.ms/autorest

This is the AutoRest configuration file for Kusto.



---
## Getting Started
To build the SDK for Kusto, simply [Install AutoRest](https://aka.ms/autorest/install) and in this folder, run:

> `autorest`

To see additional help and options, run:

> `autorest --help`
---

## Configuration



### Basic Information
These are the global settings for the Kusto API.

``` yaml
title: KustoManagementClient
description: The Azure Kusto management API provides a RESTful set of web services that interact with Azure Kusto services to manage your clusters and databases. The API enables you to create, update, and delete clusters and databases.
openapi-type: arm
tag: package-2019-01-21
```

### Tag: package-2019-01-21

These settings apply only when `--tag=package-2019-01-21` is specified on the command line.

``` yaml $(tag) == 'package-2019-01-21'
input-file:
 - Microsoft.Kusto/stable/2019-01-21/kusto.json
```

### Tag: package-2018-09-07-preview

These settings apply only when `--tag=package-2018-09-07-preview` is specified on the command line.

``` yaml $(tag) == 'package-2018-09-07-preview'
input-file:
 - Microsoft.Kusto/preview/2018-09-07-preview/kusto.json
```

### Tag: package-2017-09-07-privatepreview

These settings apply only when `--tag=package-2017-09-07-privatepreview` is specified on the command line.

``` yaml $(tag) == 'package-2017-09-07-privatepreview'
input-file:
 - Microsoft.Kusto/preview/2017-09-07-privatepreview/kusto.json
```

### Tag: schema-2019-01-21

These settings apply only when `--tag=schema-2019-01-21` is specified on the command line.

These can be regenerated by running the following PowerShell script from this readme file's folder: `dir .\Microsoft.Kusto\preview\2018-09-07-preview\ -File | Resolve-Path -Relative | % { " - $_".Replace("\", "/") }`

``` yaml $(tag) == 'schema-2019-01-21'
input-file:
 - Microsoft.Kusto/stable/2019-01-21/kusto.json
```

### Tag: schema-2018-09-07-preview

These settings apply only when `--tag=schema-2018-09-07-preview` is specified on the command line.

These can be regenerated by running the following PowerShell script from this readme file's folder: `dir .\Microsoft.Kusto\preview\2018-09-07-preview\ -File | Resolve-Path -Relative | % { " - $_".Replace("\", "/") }`

``` yaml $(tag) == 'schema-2018-09-07-preview'
input-file:
 - Microsoft.Kusto/preview/2018-09-07-preview/kusto.json
```

### Tag: schema-2017-09-07-privatepreview

These settings apply only when `--tag=schema-2017-09-07-privatepreview` is specified on the command line.

These can be regenerated by running the following PowerShell script from this readme file's folder: `dir .\Microsoft.Kusto\preview\2017-09-07-privatepreview\ -File | Resolve-Path -Relative | % { " - $_".Replace("\", "/") }`

``` yaml $(tag) == 'schema-2017-09-07-privatepreview'
input-file:
 - Microsoft.Kusto/preview/2017-09-07-privatepreview/kusto.json
```

# Code Generation


## Swagger to SDK

This section describes what SDK should be generated by the automatic system.
This is not used by Autorest itself.

``` yaml $(swagger-to-sdk)
swagger-to-sdk:
  - repo: azure-sdk-for-python
  - repo: azure-sdk-for-go
  - repo: azure-sdk-for-java
```

## C#

These settings apply only when `--csharp` is specified on the command line.
Please also specify `--csharp-sdks-folder=<path to "SDKs" directory of your azure-sdk-for-net clone>`.

``` yaml $(csharp)
csharp:
  azure-arm: true
  license-header: MICROSOFT_MIT_NO_VERSION
  namespace: Microsoft.Azure.Management.Kusto
  output-folder: $(csharp-sdks-folder)/Kusto/Management.Kusto/Generated
  clear-output-folder: true
```

## Java

These settings apply only when `--java` is specified on the command line.
Please also specify `--azure-libraries-for-java-folder=<path to the root directory of your azure-libraries-for-java clone>`.

``` yaml $(java)
azure-arm: true
fluent: true
namespace: com.microsoft.azure.management.kusto
license-header: MICROSOFT_MIT_NO_CODEGEN
payload-flattening-threshold: 1
output-folder: $(azure-libraries-for-java-folder)/azure-mgmt-kusto
```

### Java multi-api

``` yaml $(java) && $(multiapi)
batch:
  - tag: package-2018-09-07-preview
  - tag: package-2019-01-21
```

### Tag: package-2018-09-07-preview and java

These settings apply only when `--tag=package-2018-09-07-preview --java` is specified on the command line.
Please also specify `--azure-libraries-for-java=<path to the root directory of your azure-sdk-for-java clone>`.

``` yaml $(tag) == 'package-2018-09-07-preview' && $(java) && $(multiapi)
java:
  namespace: com.microsoft.azure.management.kusto.v2018_09_07_preview
  output-folder: $(azure-libraries-for-java-folder)/kusto/resource-manager/v2018_09_07_preview
regenerate-manager: true
generate-interface: true
```

### Tag: package-2019-01-21 and java

These settings apply only when `--tag=package-2019-01-21 --java` is specified on the command line.
Please also specify `--azure-libraries-for-java=<path to the root directory of your azure-sdk-for-java clone>`.

``` yaml $(tag) == 'package-2019-01-21' && $(java) && $(multiapi)
java:
  namespace: com.microsoft.azure.management.kusto.v2019_01_21
  output-folder: $(azure-libraries-for-java-folder)/kusto/resource-manager/v2019_01_21
regenerate-manager: true
generate-interface: true
```
